package com.lilosoft.api.service;

import cn.hutool.core.date.DateUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.lilosoft.api.api.OcrApi;
import com.lilosoft.api.bean.receive.ReceiveMsgInfo;
import com.lilosoft.api.service.complexWindow.CommonData;
import com.lilosoft.api.service.complexWindow.ComplexWindowAbstract;
import com.lilosoft.core.utils.Base64Helper;
import lombok.extern.slf4j.Slf4j;
import okhttp3.ResponseBody;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import retrofit2.Response;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 综窗处理类
 *
 * @author: zxfei
 * @date: 2023/10/29 10:51
 */

@Service
@Slf4j
public class ComplexService extends PublicService {

    @Autowired
    private OcrApi ocrApi;

    @Value("${api.robertServerUrl:''}")
    public String robertServerUrl;

    @Value("${complex.host:''}")
    public String complexServerUrl;

    @Value("${complex.deviceCode:''}")
    public String deviceCode;

    /**
     * 综窗申报
     */
    public String windowApply(ReceiveMsgInfo receiveMsgInfo) throws Exception {
        logger.info(JSONUtil.toJsonStr(receiveMsgInfo));
        Boolean success = receiveMsgInfo.getSuccess();
        if (success) {
            ComplexWindowAbstract complexWindowAbstract = ComplexWindowAbstract.newType(receiveMsgInfo.getItemCode());
            CommonData commonData = new CommonData();
            commonData.setRobertServerUrl(robertServerUrl);
            commonData.setComplexServerUrl(complexServerUrl);
            commonData.setDeviceLogo(deviceCode);
            commonData.setFileData(receiveMsgInfo.getFileData());
            //设置申请人信息
            Map<String, String> userData = receiveMsgInfo.getUserData();
            //申请人信息
            commonData.setApplicantName(userData.getOrDefault("applicantName",""));
            //申请人性别
            commonData.setApplicantSex(userData.getOrDefault("applicantSex",""));
            //申请人证件号码
            commonData.setApplicantIdNumber(userData.getOrDefault("applicantIdNumber",""));
            //申请人号码
            commonData.setApplicantPhone(userData.getOrDefault("applicantPhone",""));
            //申请人证件
            commonData.setApplicantDocumentId("111");
            //设置法人信息
            commonData.setLegalName(userData.getOrDefault("legalName",""));//营业执照法人姓名
            commonData.setLegalIdNumber(userData.getOrDefault("legalIdNumber",""));//法人id号
            commonData.setLegalSex(userData.getOrDefault("legalSex",""));//法人性别
            commonData.setLegalDocumentId("111");
            complexWindowAbstract.doHandleWork(commonData);
        } else {
            log.info("预审事项未通过");
        }
        String result = "";//返回结果
        boolean check = true;//事项是否查找到，默认事项已经查找到
        return result;

    }

}
